<?php

/**
 * Показ всплывающих подсказок.
 *
 * @param string $text       Help tip text.
 * @param  string   $event  danger | faq | info
 * @return string
 * @since  5.0.0
 *
 */
function bfw_help_tip(string $text, string $event='faq' ): string
{
    $text = esc_attr( $text );

    return '<span class="bfw-help-tip ' . $event . '" data-tip="' . $text . '"></span>';
}


/*-------Сортировка массива По возрастанию-------*/
function array_multisort_value()
{
    $args = func_get_args();
    $data = array_shift($args);
    foreach ($args as $n => $field) {
        if (is_string($field)) {
            $tmp = array();
            foreach ($data as $key => $row) {
                $tmp[$key] = $row[$field];
            }
            $args[$n] = $tmp;
        }
    }
    $args[] = &$data;
    call_user_func_array('array_multisort', $args);
    return array_pop($args);
}

add_action('computy_copyright', 'computy_copyright', 25);
function computy_copyright(): void
{if ( !(new BfwRoles)->is_pro()) {
    ?>
    <div class="computy_copyright"><?php echo __('With the support of', 'bonus-for-woo'); ?> <a href="https://computy.ru" target="_blank" title="Разработка на WordPress"> computy </a> </div>
<?php
}
}

/*Меняем статус поста\товара*/
if( ! function_exists( 'set_post_status_bfw' ) ) {

    function set_post_status_bfw( $post_status, $post = null ): bool
    {

        $post = get_post( $post );

        if ( ! is_object( $post ) ) {
            return false;
        }

        $post_id = wp_update_post( array(
            'ID' => $post->ID,
            'post_status' => $post_status
        ) );

        if( $post_id ) {
            return true;
        } else {
            return false;
        }
    }
}
